// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/AccelerationValue.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ACCELERATION_VALUE__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ACCELERATION_VALUE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AccelerationValue__MIN = -160
};

/// Constant 'MAX'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AccelerationValue__MAX = 161
};

/// Constant 'NEGATIVE_OUT_OF_RANGE'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AccelerationValue__NEGATIVE_OUT_OF_RANGE = -160
};

/// Constant 'POSITIVE_OUT_OF_RANGE'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AccelerationValue__POSITIVE_OUT_OF_RANGE = 160
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AccelerationValue__UNAVAILABLE = 161
};

/// Struct defined in msg/AccelerationValue in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__AccelerationValue
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE represents the value of an acceleration component in a defined coordinate system.
  ///  *
  ///  * The value shall be set to:
  ///  * - `-160` for acceleration values equal to or less than -16 m/s^2,
  ///  * - `n` (`n > -160` and `n <= 0`) to indicate negative acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
  ///  * - `n` (`n > 0` and `n < 160`) to indicate positive acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
  ///  * - `160` for acceleration values greater than 15,9 m/s^2,
  ///  * - `161` when the data is unavailable.
  ///  *
  ///  * @note: the formula for values > -160 and <160 results in rounding up to the next value. Zero acceleration is indicated using n=0.
  ///  * @unit 0,1 m/s^2
  ///  * @category: Kinematic information
  ///  * @revision: Created in V2.1.1
  /// */
  /// AccelerationValue ::= INTEGER {
  ///     negativeOutOfRange (-160),
  ///     positiveOutOfRange (160),
  ///     unavailable        (161)
  /// } (-160 .. 161)
  /// ------------------------------------------------------------------------------
  int16_t value;
} etsi_its_cpm_ts_msgs__msg__AccelerationValue;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__AccelerationValue.
typedef struct etsi_its_cpm_ts_msgs__msg__AccelerationValue__Sequence
{
  etsi_its_cpm_ts_msgs__msg__AccelerationValue * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__AccelerationValue__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ACCELERATION_VALUE__STRUCT_H_
