// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/AltitudeValue.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ALTITUDE_VALUE__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ALTITUDE_VALUE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AltitudeValue__MIN = -100000l
};

/// Constant 'MAX'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AltitudeValue__MAX = 800001l
};

/// Constant 'NEGATIVE_OUT_OF_RANGE'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AltitudeValue__NEGATIVE_OUT_OF_RANGE = -100000l
};

/// Constant 'POSTIVE_OUT_OF_RANGE'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AltitudeValue__POSTIVE_OUT_OF_RANGE = 800000l
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cpm_ts_msgs__msg__AltitudeValue__UNAVAILABLE = 800001l
};

/// Struct defined in msg/AltitudeValue in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__AltitudeValue
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE represents the altitude value in a WGS84 coordinate system.
  ///  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
  ///  *
  ///  * The value shall be set to:
  ///  * - `-100 000` if the altitude is equal to or less than -1 000 m,
  ///  * - `n` (`n > -100 000` and `n < 800 000`) if the altitude is equal to or less than n  x 0,01 metre and greater than (n-1) x 0,01 metre,
  ///  * - `800 000` if the altitude  greater than 7 999,99 m,
  ///  * - `800 001` if the information is not available.
  ///  *
  ///  * @note: the range of this DE does not use the full binary encoding range, but all reasonable values are covered. In order to cover all possible altitude ranges a larger encoding would be necessary.
  ///  * @unit: 0,01 metre
  ///  * @category: GeoReference information
  ///  * @revision: Description revised in V2.1.1 (definition of 800 000 has slightly changed)
  ///  */
  /// AltitudeValue ::= INTEGER {
  ///     negativeOutOfRange (-100000),
  ///     postiveOutOfRange  (800000),
  ///     unavailable        (800001)
  /// } (-100000..800001)
  /// ------------------------------------------------------------------------------
  int32_t value;
} etsi_its_cpm_ts_msgs__msg__AltitudeValue;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__AltitudeValue.
typedef struct etsi_its_cpm_ts_msgs__msg__AltitudeValue__Sequence
{
  etsi_its_cpm_ts_msgs__msg__AltitudeValue * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__AltitudeValue__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ALTITUDE_VALUE__STRUCT_H_
