// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/EulerAnglesWithConfidence.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__EULER_ANGLES_WITH_CONFIDENCE__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__EULER_ANGLES_WITH_CONFIDENCE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'z_angle'
// Member 'y_angle'
// Member 'x_angle'
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_angle__struct.h"

/// Struct defined in msg/EulerAnglesWithConfidence in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF represents the Euler angles which describe the orientation of an object bounding box in a Cartesian coordinate system with an associated confidence level for each angle.
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field zAngle: z-angle of object bounding box at the time of measurement, with the associated confidence.
  ///  * The angle is measured with positive values considering the object orientation turning around the z-axis using the right-hand rule, starting from the x-axis.
  ///  * This extrinsic rotation shall be applied around the centre point of the object bounding box before all other rotations.
  ///  *
  ///  * @field yAngle: optional y-angle of object bounding box at the time of measurement, with the associated confidence.
  ///  * The angle is measured with positive values considering the object orientation turning around the y-axis using the right-hand rule, starting from the z-axis.
  ///  * This extrinsic rotation shall be applied around the centre point of the object bounding box after the rotation by zAngle and before the rotation by xAngle.
  ///  *
  ///  * @field xAngle: optional x-angle of object bounding box at the time of measurement, with the associated confidence.
  ///  * The angle is measured with positive values considering the object orientation turning around the x-axis using the right-hand rule, starting from the z-axis.
  ///  * This extrinsic rotation shall be applied around the centre point of the object bounding box after all other rotations.
  ///  *
  ///  * @category: Basic information
  ///  * @revision: Created in V2.1.1
  /// */
  /// EulerAnglesWithConfidence ::= SEQUENCE {
  ///     zAngle CartesianAngle,
  ///     yAngle CartesianAngle OPTIONAL,
  ///     xAngle CartesianAngle OPTIONAL
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_cpm_ts_msgs__msg__CartesianAngle z_angle;
  etsi_its_cpm_ts_msgs__msg__CartesianAngle y_angle;
  bool y_angle_is_present;
  etsi_its_cpm_ts_msgs__msg__CartesianAngle x_angle;
  bool x_angle_is_present;
} etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence.
typedef struct etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__Sequence
{
  etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__EULER_ANGLES_WITH_CONFIDENCE__STRUCT_H_
