// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/Longitude.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__LONGITUDE__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__LONGITUDE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cpm_ts_msgs__msg__Longitude__MIN = -1800000000l
};

/// Constant 'MAX'.
enum
{
  etsi_its_cpm_ts_msgs__msg__Longitude__MAX = 1800000001l
};

/// Constant 'VALUE_NOT_USED'.
enum
{
  etsi_its_cpm_ts_msgs__msg__Longitude__VALUE_NOT_USED = -1800000000l
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cpm_ts_msgs__msg__Longitude__UNAVAILABLE = 1800000001l
};

/// Struct defined in msg/Longitude in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__Longitude
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE represents the absolute geographical longitude in a WGS84 coordinate system, providing a range of 180 degrees
  ///  * to the east or to the west of the prime meridian.
  ///  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
  ///  *
  ///  * The value shall be set to:
  ///  * - `n` (`n > -1 800 000 000` and `n < 0`) x 10^-7 degree, i.e. negative values for longitudes to the west,
  ///  * - `0` to indicate the prime meridian,
  ///  * - `n` (`n > 0` and `n < 1 800 000 001`) x 10^-7 degree, i.e. positive values for longitudes to the east,
  ///  * - `1 800 000 001` when the information is unavailable.
  ///  *
  ///  * The value -1 800 000 000 shall not be used.
  ///  *
  ///  * @unit: 10^-7 degree
  ///  * @category: GeoReference information
  ///  * @revision: Description revised in V2.1.1
  ///  */
  /// Longitude ::= INTEGER {
  ///     valueNotUsed (-1800000000),
  ///     unavailable  (1800000001)
  /// } (-1800000000..1800000001)
  /// ------------------------------------------------------------------------------
  int32_t value;
} etsi_its_cpm_ts_msgs__msg__Longitude;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__Longitude.
typedef struct etsi_its_cpm_ts_msgs__msg__Longitude__Sequence
{
  etsi_its_cpm_ts_msgs__msg__Longitude * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__Longitude__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__LONGITUDE__STRUCT_H_
