// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/LowerTriangularPositiveSemidefiniteMatrix.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__LOWER_TRIANGULAR_POSITIVE_SEMIDEFINITE_MATRIX__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__LOWER_TRIANGULAR_POSITIVE_SEMIDEFINITE_MATRIX__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'components_included_inthe_matrix'
#include "etsi_its_cpm_ts_msgs/msg/detail/matrix_included_components__struct.h"
// Member 'matrix'
#include "etsi_its_cpm_ts_msgs/msg/detail/lower_triangular_positive_semidefinite_matrix_columns__struct.h"

/// Struct defined in msg/LowerTriangularPositiveSemidefiniteMatrix in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__LowerTriangularPositiveSemidefiniteMatrix
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF represents a lower triangular positive semi-definite matrix.
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field componentsIncludedIntheMatrix: the indication of which components of a @ref PerceivedObject are included in the matrix.
  ///  * This component also implicitly indicates the number n of included components which defines the size (n x n) of the full correlation matrix "A".
  ///  *
  ///  * @field matrix: the list of cells of the lower triangular positive semi-definite matrix ordered by columns and by rows.
  ///  *
  ///  * The number of columns to be included "k" is equal to the number of included components "n" indicated by componentsIncludedIntheMatrix minus 1: k = n-1.
  ///  * These components shall be included in the order or their appearance in componentsIncludedIntheMatrix.
  ///  * Each column "i" of the lowerTriangularCorrelationMatrixColumns contains k-(i-1) values.
  ///  *
  ///  * @category: Sensing information
  ///  * @revision: Created in V2.1.1
  /// */
  /// LowerTriangularPositiveSemidefiniteMatrix ::= SEQUENCE{
  ///     componentsIncludedIntheMatrix   MatrixIncludedComponents,
  ///     matrix                          LowerTriangularPositiveSemidefiniteMatrixColumns
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_cpm_ts_msgs__msg__MatrixIncludedComponents components_included_inthe_matrix;
  etsi_its_cpm_ts_msgs__msg__LowerTriangularPositiveSemidefiniteMatrixColumns matrix;
} etsi_its_cpm_ts_msgs__msg__LowerTriangularPositiveSemidefiniteMatrix;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__LowerTriangularPositiveSemidefiniteMatrix.
typedef struct etsi_its_cpm_ts_msgs__msg__LowerTriangularPositiveSemidefiniteMatrix__Sequence
{
  etsi_its_cpm_ts_msgs__msg__LowerTriangularPositiveSemidefiniteMatrix * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__LowerTriangularPositiveSemidefiniteMatrix__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__LOWER_TRIANGULAR_POSITIVE_SEMIDEFINITE_MATRIX__STRUCT_H_
