// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/ManagementContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MANAGEMENT_CONTAINER__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MANAGEMENT_CONTAINER__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'reference_time'
#include "etsi_its_cpm_ts_msgs/msg/detail/timestamp_its__struct.h"
// Member 'reference_position'
#include "etsi_its_cpm_ts_msgs/msg/detail/reference_position__struct.h"
// Member 'segmentation_info'
#include "etsi_its_cpm_ts_msgs/msg/detail/message_segmentation_info__struct.h"
// Member 'message_rate_range'
#include "etsi_its_cpm_ts_msgs/msg/detail/message_rate_range__struct.h"

/// Struct defined in msg/ManagementContainer in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__ManagementContainer
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF  represents the management container of the CPM.
  ///  * The management container provides basic information about the originating ITS-S, which are not specific to a specific type of station.
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field referenceTime: the reference time for all time related information in the CPM.
  ///  *
  ///  * @field messageRateRange: the planned or expected range of the CPM generation rate.
  ///  *
  ///  * @field segmentationInfo: information regarding the message segmentation on facility layer.
  ///  *
  ///  * @field referencePosition: the reference position for all position related information in the CPM.
  ///  *
  /// */
  /// ManagementContainer ::= SEQUENCE {
  ///     referenceTime      TimestampIts,
  ///     referencePosition  ReferencePosition,
  ///     segmentationInfo   MessageSegmentationInfo OPTIONAL,
  ///     messageRateRange   MessageRateRange OPTIONAL,
  ///     ...
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_cpm_ts_msgs__msg__TimestampIts reference_time;
  etsi_its_cpm_ts_msgs__msg__ReferencePosition reference_position;
  etsi_its_cpm_ts_msgs__msg__MessageSegmentationInfo segmentation_info;
  bool segmentation_info_is_present;
  etsi_its_cpm_ts_msgs__msg__MessageRateRange message_rate_range;
  bool message_rate_range_is_present;
} etsi_its_cpm_ts_msgs__msg__ManagementContainer;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__ManagementContainer.
typedef struct etsi_its_cpm_ts_msgs__msg__ManagementContainer__Sequence
{
  etsi_its_cpm_ts_msgs__msg__ManagementContainer * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__ManagementContainer__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MANAGEMENT_CONTAINER__STRUCT_H_
