// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/MapPosition.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MAP_POSITION__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MAP_POSITION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'map_reference'
#include "etsi_its_cpm_ts_msgs/msg/detail/map_reference__struct.h"
// Member 'lane_id'
// Member 'connection_id'
#include "etsi_its_cpm_ts_msgs/msg/detail/identifier1_b__struct.h"
// Member 'longitudinal_lane_position'
#include "etsi_its_cpm_ts_msgs/msg/detail/longitudinal_lane_position__struct.h"

/// Struct defined in msg/MapPosition in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__MapPosition
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF indicates a position on a topology description transmitted in a MAPEM according to ETSI TS 103 301.
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field mapReference: optionally identifies the MAPEM containing the topology information.
  ///  * It is absent if the MAPEM topology is known from the context.
  ///  *
  ///  * @field laneId: optionally identifies the lane in the road segment or intersection topology on which the position is located.
  ///  *
  ///  * @field connectionId: optionally identifies the connection inside the conflict area of an intersection, i.e. it identifies a trajectory for travelling through the
  ///  * conflict area of an intersection which connects e.g an ingress with an egress lane.
  ///  *
  ///  * @field longitudinalLanePosition: optionally indicates the longitudinal offset of the map-matched position of the object along the lane or connection.
  ///  *
  ///  * @category: Road topology information
  ///  * @revision: Created in V2.1.1
  ///  */
  /// MapPosition ::= SEQUENCE {
  ///     mapReference                MapReference OPTIONAL,
  ///     laneId                      Identifier1B OPTIONAL,
  ///     connectionId                Identifier1B OPTIONAL,
  ///     longitudinalLanePosition    LongitudinalLanePosition OPTIONAL,
  ///     ...
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_cpm_ts_msgs__msg__MapReference map_reference;
  bool map_reference_is_present;
  etsi_its_cpm_ts_msgs__msg__Identifier1B lane_id;
  bool lane_id_is_present;
  etsi_its_cpm_ts_msgs__msg__Identifier1B connection_id;
  bool connection_id_is_present;
  etsi_its_cpm_ts_msgs__msg__LongitudinalLanePosition longitudinal_lane_position;
  bool longitudinal_lane_position_is_present;
} etsi_its_cpm_ts_msgs__msg__MapPosition;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__MapPosition.
typedef struct etsi_its_cpm_ts_msgs__msg__MapPosition__Sequence
{
  etsi_its_cpm_ts_msgs__msg__MapPosition * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__MapPosition__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__MAP_POSITION__STRUCT_H_
