// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/OriginatingVehicleContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ORIGINATING_VEHICLE_CONTAINER__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ORIGINATING_VEHICLE_CONTAINER__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'orientation_angle'
#include "etsi_its_cpm_ts_msgs/msg/detail/wgs84_angle__struct.h"
// Member 'pitch_angle'
// Member 'roll_angle'
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_angle__struct.h"
// Member 'trailer_data_set'
#include "etsi_its_cpm_ts_msgs/msg/detail/trailer_data_set__struct.h"

/// Struct defined in msg/OriginatingVehicleContainer in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF  represents the Originating Vehicle Container
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field orientationAngle: the angle and angle accuracy of the absolute orientation of the disseminating vehicle in the WGS84 coordinate system with respect to true North.
  ///  *
  ///  * @field pitchAngle: the optional angle and angle accuracy between the ground plane and the current orientation of the vehicle's x-axis with respect to the ground plane about the y-axis according to the ISO 8855.
  ///  *
  ///  * @field rollAngle: the optional angle and angle accuracy between the ground plane and the current orientation of a vehicle's y-axis with respect to the ground plane about the x-axis according to the ISO 8855
  ///  *
  ///  * @field trailerData: information about the trailer dimensions and orientation in case a trailer is present.
  ///  *
  /// */
  /// OriginatingVehicleContainer ::= SEQUENCE {
  ///     orientationAngle   Wgs84Angle,
  ///     pitchAngle         CartesianAngle OPTIONAL,
  ///     rollAngle          CartesianAngle OPTIONAL,
  ///     trailerDataSet     TrailerDataSet OPTIONAL,
  ///     ...
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_cpm_ts_msgs__msg__Wgs84Angle orientation_angle;
  etsi_its_cpm_ts_msgs__msg__CartesianAngle pitch_angle;
  bool pitch_angle_is_present;
  etsi_its_cpm_ts_msgs__msg__CartesianAngle roll_angle;
  bool roll_angle_is_present;
  etsi_its_cpm_ts_msgs__msg__TrailerDataSet trailer_data_set;
  bool trailer_data_set_is_present;
} etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer.
typedef struct etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__Sequence
{
  etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__OriginatingVehicleContainer__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__ORIGINATING_VEHICLE_CONTAINER__STRUCT_H_
