// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/PerceivedObject.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__PERCEIVED_OBJECT__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__PERCEIVED_OBJECT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'OBJECT_AGE_MIN'.
enum
{
  etsi_its_cpm_ts_msgs__msg__PerceivedObject__OBJECT_AGE_MIN = 0
};

/// Constant 'OBJECT_AGE_MAX'.
enum
{
  etsi_its_cpm_ts_msgs__msg__PerceivedObject__OBJECT_AGE_MAX = 2047
};

// Include directives for member types
// Member 'object_id'
#include "etsi_its_cpm_ts_msgs/msg/detail/identifier2_b__struct.h"
// Member 'measurement_delta_time'
// Member 'object_age'
#include "etsi_its_cpm_ts_msgs/msg/detail/delta_time_milli_second_signed__struct.h"
// Member 'position'
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_position3d_with_confidence__struct.h"
// Member 'velocity'
#include "etsi_its_cpm_ts_msgs/msg/detail/velocity3d_with_confidence__struct.h"
// Member 'acceleration'
#include "etsi_its_cpm_ts_msgs/msg/detail/acceleration3d_with_confidence__struct.h"
// Member 'angles'
#include "etsi_its_cpm_ts_msgs/msg/detail/euler_angles_with_confidence__struct.h"
// Member 'z_angular_velocity'
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_angular_velocity_component__struct.h"
// Member 'lower_triangular_correlation_matrices'
#include "etsi_its_cpm_ts_msgs/msg/detail/lower_triangular_positive_semidefinite_matrices__struct.h"
// Member 'object_dimension_z'
// Member 'object_dimension_y'
// Member 'object_dimension_x'
#include "etsi_its_cpm_ts_msgs/msg/detail/object_dimension__struct.h"
// Member 'object_perception_quality'
#include "etsi_its_cpm_ts_msgs/msg/detail/object_perception_quality__struct.h"
// Member 'sensor_id_list'
#include "etsi_its_cpm_ts_msgs/msg/detail/sequence_of_identifier1_b__struct.h"
// Member 'classification'
#include "etsi_its_cpm_ts_msgs/msg/detail/object_class_description__struct.h"
// Member 'map_position'
#include "etsi_its_cpm_ts_msgs/msg/detail/map_position__struct.h"

/// Struct defined in msg/PerceivedObject in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__PerceivedObject
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF contains information about a perceived object including its kinematic state and attitude vector in a pre-defined coordinate system and with respect to a reference time.
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field objectId: optional identifier assigned to a detected object.
  ///  *
  ///  * @field measurementDeltaTime: the time difference from a reference time to the time of the  measurement of the object.
  ///  * Negative values indicate that the provided object state refers to a point in time before the reference time.
  ///  *
  ///  * @field position: the position of the geometric centre of the object's bounding box within the pre-defined coordinate system.
  ///  *
  ///  * @field velocity: the velocity vector of the object within the pre-defined coordinate system.
  ///  *
  ///  * @field acceleration: the acceleration vector of the object within the pre-defined coordinate system.
  ///  *
  ///  * @field angles: optional Euler angles of the object bounding box at the time of measurement.
  ///  *
  ///  * @field zAngularVelocity: optional angular velocity of the object around the z-axis at the time of measurement.
  ///  * The angular velocity is measured with positive values considering the object orientation turning around the z-axis using the right-hand rule.
  ///  *
  ///  * @field lowerTriangularCorrelationMatrices: optional set of lower triangular correlation matrices for selected components of the provided kinematic state and attitude vector.
  ///  *
  ///  * @field objectDimensionZ: optional z-dimension of object bounding box.
  ///  * This dimension shall be measured along the direction of the z-axis after all the rotations have been applied.
  ///  *
  ///  * @field objectDimensionY: optional y-dimension of the object bounding box.
  ///  * This dimension shall be measured along the direction of the y-axis after all the rotations have been applied.
  ///  *
  ///  * @field objectDimensionX: optional x-dimension of object bounding box.
  ///  * This dimension shall be measured along the direction of the x-axis after all the rotations have been applied.
  ///  *
  ///  * @field objectAge: optional age of the detected and described object, i.e. the difference in time between the moment
  ///  * it has been first detected and the reference time of the message. Value `1500` indicates that the object has been observed for more than 1.5s.
  ///  *
  ///  * @field objectPerceptionQuality: optional confidence associated to the object.
  ///  *
  ///  * @field sensorIdList: optional list of sensor-IDs which provided the measurement data.
  ///  *
  ///  * @field classification: optional classification of the described object
  ///  *
  ///  * @field matchedPosition: optional map-matched position of an object.
  ///  *
  ///  * @category Sensing information
  ///  * @revision: created in V2.1.1
  ///  */
  /// PerceivedObject ::= SEQUENCE {
  ///     objectId                                          Identifier2B OPTIONAL,
  ///     measurementDeltaTime                              DeltaTimeMilliSecondSigned,
  ///     position                                          CartesianPosition3dWithConfidence,
  ///     velocity                                          Velocity3dWithConfidence OPTIONAL,
  ///     acceleration                                      Acceleration3dWithConfidence OPTIONAL,
  ///     angles                                            EulerAnglesWithConfidence OPTIONAL,
  ///     zAngularVelocity                                  CartesianAngularVelocityComponent OPTIONAL,
  ///     lowerTriangularCorrelationMatrices                LowerTriangularPositiveSemidefiniteMatrices OPTIONAL,
  ///     objectDimensionZ                                  ObjectDimension OPTIONAL,
  ///     objectDimensionY                                  ObjectDimension OPTIONAL,
  ///     objectDimensionX                                  ObjectDimension OPTIONAL,
  ///     objectAge                                         DeltaTimeMilliSecondSigned (0..2047) OPTIONAL,
  ///     objectPerceptionQuality                           ObjectPerceptionQuality OPTIONAL,
  ///     sensorIdList                                      SequenceOfIdentifier1B OPTIONAL,
  ///     classification                                    ObjectClassDescription OPTIONAL,
  ///     mapPosition                                       MapPosition OPTIONAL,
  ///     ...
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_cpm_ts_msgs__msg__Identifier2B object_id;
  bool object_id_is_present;
  etsi_its_cpm_ts_msgs__msg__DeltaTimeMilliSecondSigned measurement_delta_time;
  etsi_its_cpm_ts_msgs__msg__CartesianPosition3dWithConfidence position;
  etsi_its_cpm_ts_msgs__msg__Velocity3dWithConfidence velocity;
  bool velocity_is_present;
  etsi_its_cpm_ts_msgs__msg__Acceleration3dWithConfidence acceleration;
  bool acceleration_is_present;
  etsi_its_cpm_ts_msgs__msg__EulerAnglesWithConfidence angles;
  bool angles_is_present;
  etsi_its_cpm_ts_msgs__msg__CartesianAngularVelocityComponent z_angular_velocity;
  bool z_angular_velocity_is_present;
  etsi_its_cpm_ts_msgs__msg__LowerTriangularPositiveSemidefiniteMatrices lower_triangular_correlation_matrices;
  bool lower_triangular_correlation_matrices_is_present;
  etsi_its_cpm_ts_msgs__msg__ObjectDimension object_dimension_z;
  bool object_dimension_z_is_present;
  etsi_its_cpm_ts_msgs__msg__ObjectDimension object_dimension_y;
  bool object_dimension_y_is_present;
  etsi_its_cpm_ts_msgs__msg__ObjectDimension object_dimension_x;
  bool object_dimension_x_is_present;
  etsi_its_cpm_ts_msgs__msg__DeltaTimeMilliSecondSigned object_age;
  bool object_age_is_present;
  etsi_its_cpm_ts_msgs__msg__ObjectPerceptionQuality object_perception_quality;
  bool object_perception_quality_is_present;
  etsi_its_cpm_ts_msgs__msg__SequenceOfIdentifier1B sensor_id_list;
  bool sensor_id_list_is_present;
  etsi_its_cpm_ts_msgs__msg__ObjectClassDescription classification;
  bool classification_is_present;
  etsi_its_cpm_ts_msgs__msg__MapPosition map_position;
  bool map_position_is_present;
} etsi_its_cpm_ts_msgs__msg__PerceivedObject;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__PerceivedObject.
typedef struct etsi_its_cpm_ts_msgs__msg__PerceivedObject__Sequence
{
  etsi_its_cpm_ts_msgs__msg__PerceivedObject * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__PerceivedObject__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__PERCEIVED_OBJECT__STRUCT_H_
