// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/PerceptionRegion.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__PERCEPTION_REGION__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__PERCEPTION_REGION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'measurement_delta_time'
#include "etsi_its_cpm_ts_msgs/msg/detail/delta_time_milli_second_signed__struct.h"
// Member 'perception_region_confidence'
#include "etsi_its_cpm_ts_msgs/msg/detail/confidence_level__struct.h"
// Member 'perception_region_shape'
#include "etsi_its_cpm_ts_msgs/msg/detail/shape__struct.h"
// Member 'sensor_id_list'
#include "etsi_its_cpm_ts_msgs/msg/detail/sequence_of_identifier1_b__struct.h"
// Member 'number_of_perceived_objects'
#include "etsi_its_cpm_ts_msgs/msg/detail/cardinal_number1_b__struct.h"
// Member 'perceived_object_ids'
#include "etsi_its_cpm_ts_msgs/msg/detail/perceived_object_ids__struct.h"

/// Struct defined in msg/PerceptionRegion in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__PerceptionRegion
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF represents the actual perception capabilities available to the transmitting ITS-S, offering additional (often dynamic) details to the information provided in the sensor information container.
  ///  *
  ///  * It shall include the following components:
  ///
  ///  * @field measurementDeltaTime: difference between the time of estimation of the perception region and the reference time. Positive values indicates that the provided information refers to a point in time after the reference time.
  ///  *
  ///  * @field perceptionRegionConfidence: the perception confidence.
  ///  *
  ///  * @field perceptionRegionShape: specification of the shape of the perception region.
  ///  *
  ///  * @field shadowingApplies: indicates if the standard shadowing approach applies to the described perception region.
  ///  *
  ///  * @field sensorIdList: the optional list of identifiers of the sensors which are involved in perceiving the region.
  ///  *
  ///  * @field numberOfPerceivedObjects: the optional number of perceived objects contained in the perception region specified in the component perceptionRegionShape.
  ///  *
  ///  * @field perceivedObjectIds: the optional list of identifiers of the objects specified in the Perceived Object Container that are contained in the perception region specified in the component perceptionRegionShape.
  ///  *
  /// */
  /// PerceptionRegion ::= SEQUENCE {
  ///     measurementDeltaTime         DeltaTimeMilliSecondSigned,
  ///     perceptionRegionConfidence   ConfidenceLevel,
  ///     perceptionRegionShape        Shape,
  ///     shadowingApplies             BOOLEAN,
  ///     sensorIdList                 SequenceOfIdentifier1B OPTIONAL,
  ///     numberOfPerceivedObjects     CardinalNumber1B OPTIONAL,
  ///     perceivedObjectIds           PerceivedObjectIds OPTIONAL,
  ///  ...
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_cpm_ts_msgs__msg__DeltaTimeMilliSecondSigned measurement_delta_time;
  etsi_its_cpm_ts_msgs__msg__ConfidenceLevel perception_region_confidence;
  etsi_its_cpm_ts_msgs__msg__Shape perception_region_shape;
  bool shadowing_applies;
  etsi_its_cpm_ts_msgs__msg__SequenceOfIdentifier1B sensor_id_list;
  bool sensor_id_list_is_present;
  etsi_its_cpm_ts_msgs__msg__CardinalNumber1B number_of_perceived_objects;
  bool number_of_perceived_objects_is_present;
  etsi_its_cpm_ts_msgs__msg__PerceivedObjectIds perceived_object_ids;
  bool perceived_object_ids_is_present;
} etsi_its_cpm_ts_msgs__msg__PerceptionRegion;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__PerceptionRegion.
typedef struct etsi_its_cpm_ts_msgs__msg__PerceptionRegion__Sequence
{
  etsi_its_cpm_ts_msgs__msg__PerceptionRegion * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__PerceptionRegion__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__PERCEPTION_REGION__STRUCT_H_
