// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/PolygonalShape.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__POLYGONAL_SHAPE__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__POLYGONAL_SHAPE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'POLYGON_MIN_SIZE'.
enum
{
  etsi_its_cpm_ts_msgs__msg__PolygonalShape__POLYGON_MIN_SIZE = 3
};

/// Constant 'POLYGON_MAX_SIZE'.
enum
{
  etsi_its_cpm_ts_msgs__msg__PolygonalShape__POLYGON_MAX_SIZE = 16
};

// Include directives for member types
// Member 'shape_reference_point'
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_position3d__struct.h"
// Member 'polygon'
#include "etsi_its_cpm_ts_msgs/msg/detail/sequence_of_cartesian_position3d__struct.h"
// Member 'height'
#include "etsi_its_cpm_ts_msgs/msg/detail/standard_length12b__struct.h"

/// Struct defined in msg/PolygonalShape in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__PolygonalShape
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF represents the shape of a polygonal area or of a right prism.
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field shapeReferencePoint: the optional reference point used for the definition of the shape, relative to an externally specified reference position.
  ///  * If this component is absent, the externally specified reference position represents the shape's reference point.
  ///  *
  ///  * @field polygon: the polygonal area represented by a list of minimum `3` to maximum `16` @ref CartesianPosition3d.
  ///  * All nodes of the polygon shall be considered relative to the shape's reference point.
  ///  *
  ///  * @field height: the optional height, present if the shape is a right prism extending in the positive z-axis.
  ///  *
  ///  * @category GeoReference information
  ///  * @revision: created in V2.1.1
  ///  *
  ///  */
  /// PolygonalShape ::= SEQUENCE {
  ///    shapeReferencePoint    CartesianPosition3d OPTIONAL,
  ///    polygon                SequenceOfCartesianPosition3d (SIZE(3..16,...)),
  ///    height                 StandardLength12b OPTIONAL
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_cpm_ts_msgs__msg__CartesianPosition3d shape_reference_point;
  bool shape_reference_point_is_present;
  etsi_its_cpm_ts_msgs__msg__SequenceOfCartesianPosition3d polygon;
  etsi_its_cpm_ts_msgs__msg__StandardLength12b height;
  bool height_is_present;
} etsi_its_cpm_ts_msgs__msg__PolygonalShape;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__PolygonalShape.
typedef struct etsi_its_cpm_ts_msgs__msg__PolygonalShape__Sequence
{
  etsi_its_cpm_ts_msgs__msg__PolygonalShape * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__PolygonalShape__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__POLYGONAL_SHAPE__STRUCT_H_
