// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/RadialShape.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__RADIAL_SHAPE__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__RADIAL_SHAPE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'shape_reference_point'
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_position3d__struct.h"
// Member 'range'
#include "etsi_its_cpm_ts_msgs/msg/detail/standard_length12b__struct.h"
// Member 'stationary_horizontal_opening_angle_start'
// Member 'stationary_horizontal_opening_angle_end'
#include "etsi_its_cpm_ts_msgs/msg/detail/wgs84_angle_value__struct.h"
// Member 'vertical_opening_angle_start'
// Member 'vertical_opening_angle_end'
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_angle_value__struct.h"

/// Struct defined in msg/RadialShape in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__RadialShape
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF describes a radial shape. The triangular or cone-shaped volume is
  ///  * constructed by sweeping the provided range about the reference point  between a horizontal start
  ///  * and a horizontal end angle in positive angular direction of the WGS84
  ///  * coordinate system. A vertical opening angle may be provided in a Cartesian coordinate system with
  ///  * the x-axis located in the North-East plane of the WGS84 coordinate system. The sensor height may
  ///  * be provided to reflect characteristics of sensors mounted at an altitude (e.g. sensors mounted
  ///  * above intersections).
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field shapeReferencePoint: the optional reference point used for the definition of the shape, relative to an externally specified reference position.
  ///  * If this component is absent, the externally specified reference position represents the shape's  reference point.
  ///  *
  ///  * @field range: the radial range of the shape from the shape's reference point.
  ///  *
  ///  * @field stationaryHorizontalOpeningAngleStart:  the orientation indicating the beginning of the
  ///  * shape's horizontal opening angle in positive angular direction with respect to the
  ///  * WGS84 coordinate system.
  ///  *
  ///  * @field stationaryHorizontalOpeningAngleEnd: The orientation indicating the end of the shape's
  ///  * horizontal opening angle in positive angular direction with respect to the WGS84 coordinate system.
  ///  *
  ///  * @field verticalOpeningAngleStart: optional orientation indicating the beginning of the shape's
  ///  * opening angle in positive angular direction of a Cartesian coordinate system with its x-axis
  ///  * located in the north-east plane of the WGS84 coordinate system.
  ///  *
  ///  * @field verticalOpeningAngleEnd: optional orientation indicating the end of the shape's
  ///  * vertical opening angle in positive angular direction of a Cartesian coordinate system with its x-axis
  ///  * located in the north-east plane of the WGS84 coordinate system.
  ///  *
  ///  * @category GeoReference information
  ///  * @revision: created in V2.1.1
  /// */
  /// RadialShape ::= SEQUENCE {
  ///     shapeReferencePoint                      CartesianPosition3d OPTIONAL,
  ///     range                                    StandardLength12b,
  ///     stationaryHorizontalOpeningAngleStart    Wgs84AngleValue,
  ///     stationaryHorizontalOpeningAngleEnd      Wgs84AngleValue,
  ///     verticalOpeningAngleStart                CartesianAngleValue OPTIONAL,
  ///     verticalOpeningAngleEnd                  CartesianAngleValue OPTIONAL
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_cpm_ts_msgs__msg__CartesianPosition3d shape_reference_point;
  bool shape_reference_point_is_present;
  etsi_its_cpm_ts_msgs__msg__StandardLength12b range;
  etsi_its_cpm_ts_msgs__msg__Wgs84AngleValue stationary_horizontal_opening_angle_start;
  etsi_its_cpm_ts_msgs__msg__Wgs84AngleValue stationary_horizontal_opening_angle_end;
  etsi_its_cpm_ts_msgs__msg__CartesianAngleValue vertical_opening_angle_start;
  bool vertical_opening_angle_start_is_present;
  etsi_its_cpm_ts_msgs__msg__CartesianAngleValue vertical_opening_angle_end;
  bool vertical_opening_angle_end_is_present;
} etsi_its_cpm_ts_msgs__msg__RadialShape;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__RadialShape.
typedef struct etsi_its_cpm_ts_msgs__msg__RadialShape__Sequence
{
  etsi_its_cpm_ts_msgs__msg__RadialShape * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__RadialShape__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__RADIAL_SHAPE__STRUCT_H_
