// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/RectangularShape.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__RECTANGULAR_SHAPE__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__RECTANGULAR_SHAPE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'center_point'
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_position3d__struct.h"
// Member 'semi_length'
// Member 'semi_breadth'
// Member 'height'
#include "etsi_its_cpm_ts_msgs/msg/detail/standard_length12b__struct.h"
// Member 'orientation'
#include "etsi_its_cpm_ts_msgs/msg/detail/wgs84_angle_value__struct.h"

/// Struct defined in msg/RectangularShape in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__RectangularShape
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF represents the shape of a rectangular area or a right rectangular prism that is centred on a reference position defined outside of the context of this DF.
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field centerPoint: represents an optional offset point which the rectangle is centred on with respect to the reference position.
  ///  *
  ///  * @field semiLength: represents half the length of the rectangle.
  ///  *
  ///  * @field semiBreadth: represents half the breadth of the rectangle.
  ///  *
  ///  * @field orientation: represents the optional orientation of the lenght of the rectangle in the WGS84 coordinate system.
  ///  * The specific WGS84 coordinate system is specified by the corresponding standards applying this DE.
  ///  *
  ///  * @field height: represents the optional height, present if the shape is a right rectangular prism with height extending in the positive z-axis.
  ///  *
  ///  * @category GeoReference information
  ///  * @revision: created in V2.1.1
  ///  */
  /// RectangularShape ::= SEQUENCE {
  ///     centerPoint    CartesianPosition3d OPTIONAL,
  ///     semiLength     StandardLength12b,
  ///     semiBreadth    StandardLength12b,
  ///     orientation    Wgs84AngleValue OPTIONAL,
  ///     height         StandardLength12b OPTIONAL
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_cpm_ts_msgs__msg__CartesianPosition3d center_point;
  bool center_point_is_present;
  etsi_its_cpm_ts_msgs__msg__StandardLength12b semi_length;
  etsi_its_cpm_ts_msgs__msg__StandardLength12b semi_breadth;
  etsi_its_cpm_ts_msgs__msg__Wgs84AngleValue orientation;
  bool orientation_is_present;
  etsi_its_cpm_ts_msgs__msg__StandardLength12b height;
  bool height_is_present;
} etsi_its_cpm_ts_msgs__msg__RectangularShape;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__RectangularShape.
typedef struct etsi_its_cpm_ts_msgs__msg__RectangularShape__Sequence
{
  etsi_its_cpm_ts_msgs__msg__RectangularShape * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__RectangularShape__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__RECTANGULAR_SHAPE__STRUCT_H_
