// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/SensorInformation.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__SENSOR_INFORMATION__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__SENSOR_INFORMATION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'sensor_id'
#include "etsi_its_cpm_ts_msgs/msg/detail/identifier1_b__struct.h"
// Member 'sensor_type'
#include "etsi_its_cpm_ts_msgs/msg/detail/sensor_type__struct.h"
// Member 'perception_region_shape'
#include "etsi_its_cpm_ts_msgs/msg/detail/shape__struct.h"
// Member 'perception_region_confidence'
#include "etsi_its_cpm_ts_msgs/msg/detail/confidence_level__struct.h"

/// Struct defined in msg/SensorInformation in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__SensorInformation
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF  represents the characteristics of a single sensor or data fusion system.
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field sensorId: identifier of the sensor or data fusion system used to relate the perceived object in the Perceived Object Container to the sensor that detected it.
  ///  * this identifier shall uniquely identify the sensor inside the CPM, but may be changed from one CPM to the next.
  ///  *
  ///  * @field sensorType: the type of the sensor.
  ///  *
  ///  * @field perceptionRegionShape: the perception region of the sensor.
  ///  *
  ///  * @field perceptionRegionConfidence: the homogeneous perception region confidence that can be assumed for the entire perception region shape of this sensor.
  ///  *
  ///  * @field shadowingApplies: indicates if the standard shadowing approach applies to the described perception region.
  ///  *
  /// */
  /// SensorInformation ::= SEQUENCE {
  ///     sensorId                Identifier1B,
  ///     sensorType              SensorType,
  ///     perceptionRegionShape  Shape OPTIONAL,
  ///     perceptionRegionConfidence  ConfidenceLevel OPTIONAL,
  ///     shadowingApplies            BOOLEAN,
  ///    ...
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_cpm_ts_msgs__msg__Identifier1B sensor_id;
  etsi_its_cpm_ts_msgs__msg__SensorType sensor_type;
  etsi_its_cpm_ts_msgs__msg__Shape perception_region_shape;
  bool perception_region_shape_is_present;
  etsi_its_cpm_ts_msgs__msg__ConfidenceLevel perception_region_confidence;
  bool perception_region_confidence_is_present;
  bool shadowing_applies;
} etsi_its_cpm_ts_msgs__msg__SensorInformation;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__SensorInformation.
typedef struct etsi_its_cpm_ts_msgs__msg__SensorInformation__Sequence
{
  etsi_its_cpm_ts_msgs__msg__SensorInformation * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__SensorInformation__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__SENSOR_INFORMATION__STRUCT_H_
