// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/TrailerData.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__TRAILER_DATA__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__TRAILER_DATA__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'ref_point_id'
#include "etsi_its_cpm_ts_msgs/msg/detail/identifier1_b__struct.h"
// Member 'hitch_point_offset'
// Member 'front_overhang'
// Member 'rear_overhang'
#include "etsi_its_cpm_ts_msgs/msg/detail/standard_length1_b__struct.h"
// Member 'trailer_width'
#include "etsi_its_cpm_ts_msgs/msg/detail/vehicle_width__struct.h"
// Member 'hitch_angle'
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_angle__struct.h"

/// Struct defined in msg/TrailerData in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__TrailerData
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF provides detailed information about an attached trailer.
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field refPointId: identifier of the reference point of the trailer.
  ///  *
  ///  * @field hitchPointOffset: optional position of the hitch point in negative x-direction (according to ISO 8855) from the
  ///  * vehicle Reference Point.
  ///  *
  ///  * @field frontOverhang: optional length of the trailer overhang in the positive x direction (according to ISO 8855) from the
  ///  * trailer Reference Point indicated by the refPointID. The value defaults to 0 in case the trailer
  ///  * is not overhanging to the front with respect to the trailer reference point.
  ///  *
  ///  * @field rearOverhang: optional length of the trailer overhang in the negative x direction (according to ISO 8855) from the
  ///  * trailer Reference Point indicated by the refPointID.
  ///  *
  ///  * @field trailerWidth: optional width of the trailer.
  ///  *
  ///  * @field hitchAngle: optional Value and confidence value of the angle between the trailer orientation (corresponding to the x
  ///  * direction of the ISO 8855 coordinate system centered on the trailer) and the direction of
  ///  * the segment having as end points the reference point of the trailer and the reference point of
  ///  * the pulling vehicle, which can be another trailer or a vehicle looking on the horizontal plane
  ///  * xy, described in the local Cartesian coordinate system of the trailer. The
  ///  * angle is measured with negative values considering the trailer orientation turning clockwise
  ///  * starting from the segment direction. The angle value accuracy is provided with the
  ///  * confidence level of 95 %.
  ///  *
  ///  * @category: Vehicle information
  ///  * @revision: Created in V2.1.1
  /// */
  /// TrailerData ::= SEQUENCE {
  ///     refPointId          Identifier1B,
  ///     hitchPointOffset    StandardLength1B,
  ///     frontOverhang       StandardLength1B OPTIONAL,
  ///     rearOverhang        StandardLength1B OPTIONAL,
  ///     trailerWidth        VehicleWidth OPTIONAL,
  ///     hitchAngle          CartesianAngle,
  ///     ...
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_cpm_ts_msgs__msg__Identifier1B ref_point_id;
  etsi_its_cpm_ts_msgs__msg__StandardLength1B hitch_point_offset;
  etsi_its_cpm_ts_msgs__msg__StandardLength1B front_overhang;
  bool front_overhang_is_present;
  etsi_its_cpm_ts_msgs__msg__StandardLength1B rear_overhang;
  bool rear_overhang_is_present;
  etsi_its_cpm_ts_msgs__msg__VehicleWidth trailer_width;
  bool trailer_width_is_present;
  etsi_its_cpm_ts_msgs__msg__CartesianAngle hitch_angle;
} etsi_its_cpm_ts_msgs__msg__TrailerData;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__TrailerData.
typedef struct etsi_its_cpm_ts_msgs__msg__TrailerData__Sequence
{
  etsi_its_cpm_ts_msgs__msg__TrailerData * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__TrailerData__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__TRAILER_DATA__STRUCT_H_
