// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/VelocityPolarWithZ.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VELOCITY_POLAR_WITH_Z__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VELOCITY_POLAR_WITH_Z__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'velocity_magnitude'
#include "etsi_its_cpm_ts_msgs/msg/detail/speed__struct.h"
// Member 'velocity_direction'
#include "etsi_its_cpm_ts_msgs/msg/detail/cartesian_angle__struct.h"
// Member 'z_velocity'
#include "etsi_its_cpm_ts_msgs/msg/detail/velocity_component__struct.h"

/// Struct defined in msg/VelocityPolarWithZ in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF represents a velocity vector in a polar or cylindrical coordinate system.
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field velocityMagnitude: magnitude of the velocity vector on the reference plane, with the associated confidence value.
  ///  *
  ///  * @field velocityDirection: polar angle of the velocity vector on the reference plane, with the associated confidence value.
  ///  *
  ///  * @field zVelocity: the optional z component of the velocity vector along the reference axis of the cylindrical coordinate system, with the associated confidence value.
  ///  *
  ///  * @category: Kinematic information
  ///  * @revision: Created in V2.1.1
  ///  */
  /// VelocityPolarWithZ::= SEQUENCE {
  ///     velocityMagnitude    Speed,
  ///     velocityDirection    CartesianAngle,
  ///     zVelocity            VelocityComponent OPTIONAL
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_cpm_ts_msgs__msg__Speed velocity_magnitude;
  etsi_its_cpm_ts_msgs__msg__CartesianAngle velocity_direction;
  etsi_its_cpm_ts_msgs__msg__VelocityComponent z_velocity;
  bool z_velocity_is_present;
} etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ.
typedef struct etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__Sequence
{
  etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__VelocityPolarWithZ__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VELOCITY_POLAR_WITH_Z__STRUCT_H_
