// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/VruClusterInformation.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VRU_CLUSTER_INFORMATION__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VRU_CLUSTER_INFORMATION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'cluster_id'
#include "etsi_its_cpm_ts_msgs/msg/detail/identifier1_b__struct.h"
// Member 'cluster_bounding_box_shape'
#include "etsi_its_cpm_ts_msgs/msg/detail/shape__struct.h"
// Member 'cluster_cardinality_size'
#include "etsi_its_cpm_ts_msgs/msg/detail/cardinal_number1_b__struct.h"
// Member 'cluster_profiles'
#include "etsi_its_cpm_ts_msgs/msg/detail/vru_cluster_profiles__struct.h"

/// Struct defined in msg/VruClusterInformation in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__VruClusterInformation
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF provides information about a VRU cluster.
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field clusterId: optional identifier of a VRU cluster .
  ///  *
  ///  * @field clusterBoundingBoxShape: optionally indicates the shape of the cluster bounding box.
  ///  *
  ///  * @field clusterCardinalitySize: indicates an estimation of the number of VRUs in the group, i.e. the known members in the cluster + 1 (for the cluster leader) .
  ///  *
  ///  * @field clusterProfiles: optionally identifies all the VRU profile types that are known to be within the cluster.
  ///  * if this component is absent it means that the information is unavailable.
  ///  *
  ///  * @category: VRU information
  ///  * @revision: Created in V2.1.1
  /// */
  /// VruClusterInformation ::= SEQUENCE {
  ///    clusterId                  Identifier1B OPTIONAL,
  ///    clusterBoundingBoxShape    Shape (WITH COMPONENTS{..., elliptical ABSENT, radial ABSENT, radialShapes ABSENT}) OPTIONAL,
  ///    clusterCardinalitySize     CardinalNumber1B,
  ///    clusterProfiles            VruClusterProfiles OPTIONAL,
  ///    ...
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_cpm_ts_msgs__msg__Identifier1B cluster_id;
  bool cluster_id_is_present;
  etsi_its_cpm_ts_msgs__msg__Shape cluster_bounding_box_shape;
  bool cluster_bounding_box_shape_is_present;
  etsi_its_cpm_ts_msgs__msg__CardinalNumber1B cluster_cardinality_size;
  etsi_its_cpm_ts_msgs__msg__VruClusterProfiles cluster_profiles;
  bool cluster_profiles_is_present;
} etsi_its_cpm_ts_msgs__msg__VruClusterInformation;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__VruClusterInformation.
typedef struct etsi_its_cpm_ts_msgs__msg__VruClusterInformation__Sequence
{
  etsi_its_cpm_ts_msgs__msg__VruClusterInformation * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__VruClusterInformation__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VRU_CLUSTER_INFORMATION__STRUCT_H_
