// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cpm_ts_msgs:msg/VruClusterProfiles.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VRU_CLUSTER_PROFILES__STRUCT_H_
#define ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VRU_CLUSTER_PROFILES__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'SIZE_BITS'.
enum
{
  etsi_its_cpm_ts_msgs__msg__VruClusterProfiles__SIZE_BITS = 4
};

/// Constant 'BIT_INDEX_PEDESTRIAN'.
enum
{
  etsi_its_cpm_ts_msgs__msg__VruClusterProfiles__BIT_INDEX_PEDESTRIAN = 0
};

/// Constant 'BIT_INDEX_BICYCLIST'.
enum
{
  etsi_its_cpm_ts_msgs__msg__VruClusterProfiles__BIT_INDEX_BICYCLIST = 1
};

/// Constant 'BIT_INDEX_MOTORCYCLIST'.
enum
{
  etsi_its_cpm_ts_msgs__msg__VruClusterProfiles__BIT_INDEX_MOTORCYCLIST = 2
};

/// Constant 'BIT_INDEX_ANIMAL'.
enum
{
  etsi_its_cpm_ts_msgs__msg__VruClusterProfiles__BIT_INDEX_ANIMAL = 3
};

// Include directives for member types
// Member 'value'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in msg/VruClusterProfiles in the package etsi_its_cpm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cpm_ts_msgs__msg__VruClusterProfiles
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/cpm_ts103324/asn/CPM-PDU-Descriptions.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-OriginatingStationContainers.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceivedObjectContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-PerceptionRegionContainer.asn
  ///   asn1/raw/cpm_ts103324/asn/CPM-SensorInformationContainer.asn
  ///   asn1/patched/cpm_ts103324/asn/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   cpm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_cpm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE Identifies all the VRU profile types within a cluster.
  ///  * It consist of a Bitmap encoding VRU profiles, to allow multiple profiles to be indicated in a single cluster (heterogeneous cluster if more than one profile).
  ///  *
  ///  * The corresponding bit shall be set to 1 under the following conditions:
  ///  * - 0 `pedestrian`  - indicates that the VRU cluster contains at least one pedestrian VRU,
  ///  * - 1 `bicycle`     - indicates that the VRU cluster contains at least one bicycle VRU member,
  ///  * - 2 `motorcyclist`- indicates that the VRU cluster contains at least one motorcycle VRU member,
  ///  * - 3 `animal`      - indicates that the VRU cluster contains at least one animal VRU member.
  ///  *
  ///  * Otherwise, the corresponding bit shall be set to 0.
  ///  *
  ///  * @category: VRU information
  ///  * @revision: Created in V2.1.1
  /// */
  /// VruClusterProfiles ::= BIT STRING {
  ///     pedestrian   (0),
  ///     bicyclist    (1),
  ///     motorcyclist (2),
  ///     animal       (3)
  /// } (SIZE(4))
  /// ------------------------------------------------------------------------------
  rosidl_runtime_c__uint8__Sequence value;
  uint8_t bits_unused;
} etsi_its_cpm_ts_msgs__msg__VruClusterProfiles;

// Struct for a sequence of etsi_its_cpm_ts_msgs__msg__VruClusterProfiles.
typedef struct etsi_its_cpm_ts_msgs__msg__VruClusterProfiles__Sequence
{
  etsi_its_cpm_ts_msgs__msg__VruClusterProfiles * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cpm_ts_msgs__msg__VruClusterProfiles__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CPM_TS_MSGS__MSG__DETAIL__VRU_CLUSTER_PROFILES__STRUCT_H_
